<?php
class Bootstrap extends Zend_Application_Bootstrap_Bootstrap
{
    protected function _initAutoload()
    {
        $autoloader = new Zend_Application_Module_Autoloader(array(
            'namespace' => 'Default_',
            'basePath'  => dirname(__FILE__),
        ));
        return $autoloader;
    }

    protected function _initDoctype()
    {
        $this->bootstrap('view');
        $view = $this->getResource('view');
        $view->doctype('XHTML1_STRICT');
    }

    protected function _initHelpers()
    {
        Zend_Controller_Action_HelperBroker::addPrefix('App_Controller_Action_Helper');
    }

    protected function _initLocale()
    {
        $traduccion = new Zend_Translate('array', APPLICATION_PATH . '/langs/es.php', 'es');
        Zend_Form::setDefaultTranslator($traduccion);
    }

    protected function _initMail()
    {
        $config = array(
            'auth'      => 'login',
            'username'  => 'no-responder@expressauto.cl',
            'password'  => '8289Q3',
            'ssl'       => 'tls',
            'port'      => 587
        );

        $transport = new Zend_Mail_Transport_Smtp('smtp.gmail.com', $config);
        Zend_Mail::setDefaultTransport($transport);
    }

    protected function _initDompdf()
    {
        require_once('dompdf/dompdf_config.inc.php');
        $autoloader = Zend_Loader_Autoloader::getInstance();
        $autoloader->pushAutoloader('DOMPDF_autoload', '');

        $documentRoot = 'http://www.expressauto.cl';
        Zend_Registry::set('documentRoot', $documentRoot);
    }

    protected function _initRouter()
    {
        $frontController = Zend_Controller_Front::getInstance();
        $router = $frontController->getRouter();
        $router->addRoute(
            'descripcion',
            new Zend_Controller_Router_Route('/descripcion',
                array('controller' => 'index','action' => 'descripcion')
            ));

        $router->addRoute(
            'servicios',
            new Zend_Controller_Router_Route('/servicios',
                array('controller' => 'index','action' => 'servicios')
            ));

        $router->addRoute(
            'productos',
            new Zend_Controller_Router_Route('/productos',
                array('controller' => 'index','action' => 'productos')
            ));

        $router->addRoute(
            'contacto',
            new Zend_Controller_Router_Route('/contacto',
                array('controller' => 'index','action' => 'contacto')
            ));

        $router->addRoute(
            'contacto-and-subject',
            new Zend_Controller_Router_Route('/contacto/:subject',
                array('controller' => 'index','action' => 'contacto')
            ));

        $router->addRoute(
            'ubicacion',
            new Zend_Controller_Router_Route('/ubicacion',
                array('controller' => 'index','action' => 'ubicacion')
            ));

        $router->addRoute(
            'politicas',
            new Zend_Controller_Router_Route('/politicas-privacidad',
                array('controller' => 'index','action' => 'politicas-privacidad')
            ));

        $router->addRoute(
            'ayuda',
            new Zend_Controller_Router_Route('/ayuda',
                array('controller' => 'ayuda','action' => 'index')
            ));

        $router->addRoute(
            'mapa',
            new Zend_Controller_Router_Route('/mapa-sitio',
                array('controller' => 'ayuda','action' => 'mapa-sitio')
            ));

        $router->addRoute(
            'iniciar-sesion',
            new Zend_Controller_Router_Route('/iniciar-sesion',
                array('controller' => 'acceso','action' => 'iniciar-sesion')
            ));

        $router->addRoute(
            'logout',
            new Zend_Controller_Router_Route('/logout',
                array('controller' => 'acceso','action' => 'logout')
            ));

        $router->addRoute(
            'confirmar-registro',
            new Zend_Controller_Router_Route('/registro/c/:usuario/:cliente/:suma',
                array('controller' => 'registro', 'action' => 'confirmacion')
            ));

        $router->addRoute(
            'confirmar-registro-interno',
            new Zend_Controller_Router_Route('/registro/d/:usuario/:cliente/:suma',
                array('controller' => 'registro', 'action' => 'confirmacion-interna')
            ));

        $router->addRoute(
            'nueva-clave',
            new Zend_Controller_Router_Route('/ayuda/n/:id/:suma',
                array('controller' => 'ayuda', 'action' => 'nueva-clave')
            ));

        $router->addRoute(
            'acceso-demo',
            new Zend_Controller_Router_Route('/acceso-demo',
                array('controller' => 'acceso-demo','action' => 'index')
            ));

        $router->addRoute(
            'exportar-pdf',
            new Zend_Controller_Router_Route('/modulo-cliente/informe-pdf/:vehiculo/:fecha_i/:fecha_t',
                array('controller' => 'modulo-cliente','action' => 'informe-pdf')
            ));
    }
}