<?php
class AyudaController extends Zend_Controller_Action
{
    public function init()
    {
        $response = $this->getResponse();
        $auth = Zend_Auth::getInstance(); 
        if (!$auth->hasIdentity()) { 
            $response->insert('header', $this->view->render('header.phtml'));     
        } else {
            $this->view->usuario = Zend_Auth::getInstance()->getIdentity();
            if($mSession->type_session=='demo') {
                $response->insert('header', $this->view->render('header-demo.phtml'));
            } else {
                $response->insert('header', $this->view->render('header-user.phtml'));
            }
        }
        $response->insert('footer', $this->view->render('footer.phtml')); 
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');
        
        if($mSession->mensajes!='') { 
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = ''; 
        }
        
        $this->view->title = "ExpressAuto S.p.A. - Ayuda";
    }
    
    public function solicitarClaveAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');
        
        if($mSession->mensajes!='') { 
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = ''; 
        }
        
        $form = new Default_Form_RecuperarClave();
        
        if ($this->_request->isPost()) {
            $formData = $this->_request->getPost();
            if ($form->isValid($formData)) {

                $mail = $form->getValue('mail');
                $usuario = new Default_Model_Usuario();
                $where = $usuario->getAdapter()->quoteInto("mail=?", $mail);
                $row = $usuario->fetchRow($where)->toArray();

                $suma = md5($row['nombre']);

                $enlace = 'http://www.expressauto.cl/ayuda/n/' . $row['id'] . '/' . $suma ;

                $mail = new App_HtmlMailer('UTF-8');
                $mail->setSubject('Solicitud restablecimiento de clave')
                     ->addTo($form->getValue('mail'))
                     ->setViewParam('enlace', $enlace)
                     ->setViewParam('nombre', $row['nombre'])
                     ->sendHtmlTemplate('instrucciones-restablecimiento-clave.phtml');

                $this->view->solicitud_enviada = 'SI';
                 
            } else {
                $form->populate($formData);
            }
        }
        
        $this->view->form = $form;
        $this->view->title = "ExpressAuto S.p.A. - Ayuda";
    }
    
    public function nuevaClaveAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');
        
        if($mSession->mensajes!='') { 
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = ''; 
        }
        
        $request = $this->getRequest();
        $form = new Default_Form_NuevaClave();

        $id = (int)$this->_getParam('id');
        $suma = $this->_getParam('suma');

        $options = array('table' => 'usuarios_web', 'field' => 'id');
        $usuario_validator = new Zend_Validate_Db_RecordExists($options);

        if($usuario_validator->isValid($id)){
            $usuario_validator = new Zend_Validate_Db_RecordExists($options);
            $form->id->setValue($id);
        }

        if ($this->getRequest()->isPost()) {

            if ($form->isValid($request->getPost())) {
                
                try {

                    $usuario = new Default_Model_Usuario();
                    $where = $usuario->getAdapter()->quoteInto("id=?", $id);
                    $row = $usuario->fetchRow($where);
                    $row->clave = md5($form->getValue('clave1'));
                    $row->save();

                    $mSession->mensajes[] = 'La clave fue cambiada exitosamente. Puede ingresar con ella a partir de ahora.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_redirect('/acceso/iniciar-sesion');
                    
                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar modificar la clave.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/acceso/iniciar-sesion');
                }

            } else {
                $form->populate($request->getPost());
            }
        }
        $this->view->form = $form;
        $this->view->title = "ExpressAuto S.p.A. - Ayuda";
    }

    public function cambiarClaveAction()
    {
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $this->_redirect('/iniciar-sesion');
        }

        $this->usuario = Zend_Auth::getInstance()->getIdentity();
        
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $request = $this->getRequest();
        $form = new Default_Form_CambiarClave();

        if ($this->getRequest()->isPost()) {
            
            if ($form->isValid($request->getPost())) {

                try {

                    $usuario = new Default_Model_Usuario();
                    $where = $usuario->getAdapter()->quoteInto("id=?", $this->usuario->id);
                    $row = $usuario->fetchRow($where);
                    $row->clave = md5($form->getValue('clave1'));
                    $row->save();

                    $mSession->mensajes[] = 'La clave fue cambiada exitosamente. Puede ingresar con ella a partir de ahora.';
                    $mSession->claseMensaje = 'confirmacion';

                    $this->_redirect('/modulo-cliente');

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un error al intentar modificar la clave.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/modulo-cliente');
                }

            } else {

                $mSession->mensajes[] = 'La clave ingresada no es válida, por favor '
                                    . 'asegúrese que tenga entre 6 y 10 dígitos alfanuméricos.';
                $mSession->claseMensaje = 'errors';
                $this->_redirect('/modulo-cliente');
            }
        }
    }

    public function mapaSitioAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $this->view->title = "ExpressAuto S.p.A. - Mapa del sitio";
    }
}