<?php
class ContactoController extends Zend_Controller_Action
{
    public function init()
    {
        $this->view->seccion = '8';
        $response = $this->getResponse();
        
        $auth = Zend_Auth::getInstance(); 
        if (!$auth->hasIdentity()) { 
            $response->insert('header', $this->view->render('header.phtml'));     
        } else {
            $this->view->usuario = Zend_Auth::getInstance()->getIdentity();
            $response->insert('header', $this->view->render('header-user.phtml'));    
        }
        $response->insert('footer', $this->view->render('footer.phtml'));  
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');
        
        $this->view->title = "ExpressAuto S.p.A. - Contacto";
        
        if($mSession->mensajes!='') { 
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = ''; 
        }
        
        $form = new Default_Form_Contacto();
        $form->setAction('/contacto/');
        
        if ($this->_request->isPost()) {
            $formData = $this->_request->getPost();
            if ($form->isValid($formData)) {

                try {

                    $mail = new App_HtmlMailer('UTF-8');
                    $mail->setSubject('Mensaje de contacto')
                         ->addTo('claudiosalazarb@gmail.com')
                         ->setViewParam('remitente', $form->getValue('nombre'))
                         ->setViewParam('empresa', $form->getValue('empresa'))
                         ->setViewParam('telefono', $form->getValue('telefono'))
                         ->setViewParam('asunto', $form->getValue('asunto'))
                         ->setViewParam('detalles', $form->getValue('detalles'))
                         ->sendHtmlTemplate('contacto.phtml');

                    $mSession->mensajes = array('Su mensaje se envió de forma satisfactoria. Nos pondremos en contacto con usted a la brevedad.');
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un problema al enviar su mensaje, por favor inténtelo nuevamente más tarde.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';
                    
                }

                $this->_redirect('/contacto');

            } else {
                $this->view->mensajes = array('No ha ingresado la información solicitada para enviar su mensaje.');
                $this->view->claseMensaje = 'errors';
                $form->populate($formData);
            }
        }

        
        $this->view->form = $form;
    }
}