<?php
class DemoAccesoController extends Zend_Controller_Action
{
    public function init()
    {
        $response = $this->getResponse();

        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $response->insert('header', $this->view->render('header.phtml'));
        } else {
            $this->view->usuario = Zend_Auth::getInstance()->getIdentity();
            $response->insert('header', $this->view->render('header-user.phtml'));
        }
        $response->insert('footer', $this->view->render('footer.phtml'));
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');
        
        if($mSession->mensajes!='') { 
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = ''; 
        }
        
        $this->view->title = "ExpressAuto S.p.A. - Acceso Demo Clientes";
        
        $form = new Default_Form_Acceso();
        $form->setAction('/demo-acceso');
        
        if ($this->_request->isPost()) {
            $formData = $this->_request->getPost();
            if ($form->isValid($formData)) {
                
                $db = Zend_Db_Table_Abstract::getDefaultAdapter();
                $authAdapter = new Zend_Auth_Adapter_DbTable($db); 
                $authAdapter->setTableName('demo_usuarios_web');
                $authAdapter->setIdentityColumn('mail'); 
                $authAdapter->setCredentialColumn('clave'); 
                 
                // Set the input credential values to authenticate against 
                $authAdapter->setIdentity($form->getValue('mail')); 
                $authAdapter->setCredential(md5($form->getValue('clave')));
                 
                // do the authentication  
                $auth = Zend_Auth::getInstance(); 
                $result = $auth->authenticate($authAdapter); 

                if ($result->isValid()) {
                    
                    $data = $authAdapter->getResultRowObject(null, 'password');
                    $auth->getStorage()->write($data);
                    $mSession->type_session = 'demo';
                    $this->_redirect('/demo');

                } else {

                    $mSession->mensajes[] = 'Los datos ingresados no son válidos, por favor inténtelo nuevamente.';
                    $mSession->claseMensaje = 'errors';
                    $this->_redirect('/demo-acceso');
                }     
            } else {
                $form->populate($formData);
            }
        }
        
        $this->view->form = $form;
    }
    
    public function logoutAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');
        if($mSession->mensajes=='') {
            $mSession->mensajes[] = 'La sesión ha concluído satisfactoriamente.';
            $mSession->claseMensaje = 'advertencia';
        }
        $this->_redirect('/demo-acceso');
    } 
}