<?php
class DemoUsuarioController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();
        if(!$auth->hasIdentity()){
            $this->_redirect('/demo-acceso');
        } else {
            $mSession = new Zend_Session_Namespace('expressauto');
            if($mSession->type_session!='demo') {
                $this->_redirect('/');
            }
        }
    }

    public function init()
    {
        $this->usuario = $this->view->usuario = Zend_Auth::getInstance()->getIdentity();
        $response = $this->getResponse();
        $response->insert('header', $this->view->render('header-demo.phtml'));
        $response->insert('footer', $this->view->render('footer.phtml'));
    }
       
    public function newAction()
    {
        
        $mSession = new Zend_Session_Namespace('expressauto');
        
        if($mSession->mensajes!='') { 
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = ''; 
        }
        
        $form = new Default_Form_Usuario('/demo/index#usuarios');
        $form->setAction('/demo-usuario/new');
        $this->view->form = $form;
        $this->view->title = "ExpressAuto S.p.A. - Nuevo usuario";
        
        if ($this->_request->isPost()) { 
            $formData = $this->_request->getPost(); 
            if ($form->isValid($formData)) {
                if($form->getValue('clave1')==$form->getValue('clave2')) {
                    
                    $mSession->mensajes[] = 'El usuario fue creado de forma exitosa. (En realidad NO, ya que es una demo)';
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/demo/index#usuarios');
                    
                } else {
                    $this->view->mensajes = array('Las claves ingresadas no son iguales.');
                    $this->claseMensaje = 'errors';
                    $form->populate($formData);   
                } 
            } else {
                $form->populate($formData);    
            }
        }
    }

    public function editAction()
    {

        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $form = new Default_Form_Usuario('/demo/index#usuarios');
        $form->setAction('/demo-usuario/edit');
        $form->submit->setLabel('Guardar cambios');
        
        $this->view->title = "ExpressAuto S.p.A. - Editar usuario";

        if ($this->_request->isPost()) {
            $formData = $this->_request->getPost();
            if ($form->isValid($formData)) {
                if($form->getValue('clave1')==$form->getValue('clave2')) {

                    $usuario = new Default_Model_DemoUsuarioWeb();
                    $id = (int)$form->getValue('id');

                    $row = $usuario->fetchRow('id='.$id);
                    $row->nombre = $form->getValue('nombre');
                    $row->telefono = $form->getValue('telefono');
                    $row->movil = $form->getValue('movil');
                    $row->fax = $form->getValue('fax');
                    $row->mail = $form->getValue('mail');
                    $row->save();
                    $mSession->mensajes[] = 'El registro fue editado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';
                } else {
                    $this->view->mensajes = array('Las claves ingresadas no son iguales.');
                    $this->claseMensaje = 'errors';
                    $form->populate($formData);
                }
                $this->_redirect('/demo/index#usuarios');
            } else {
                $form->populate($formData);
            }
        } else {

            $id = (int)$this->_request->getParam('id', 0);
            $usuario = new Default_Model_DemoUsuarioWeb();
            $row = $usuario->fetchRow('id='.$id);
            $form->populate($row->toArray());
            if($row->id==$this->usuario->id){
                $form->tipo->setAttrib('disabled', 'disabled');
            }
            $this->view->form = $form;
        }
    }

    public function deshabilitarAction()
    {

        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $usuario = new Default_Model_DemoUsuarioWeb();
        $id = (int)$this->_getParam('id');

        $row = $usuario->fetchRow('id='.$id);
        $row->estado = 'DESHABILITADO';
        $row->save();

        $mSession->mensajes[] = 'El registro fue editado de forma exitosa.';
        $mSession->claseMensaje = 'confirmacion';
        $this->_redirect('/modulo-cliente/admin#usuarios');

    }

    public function habilitarAction()
    {

        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $usuario = new Default_Model_DemoUsuarioWeb();
        $id = (int)$this->_getParam('id');

        $row = $usuario->fetchRow('id='.$id);
        $row->estado = 'HABILITADO';
        $row->save();

        $mSession->mensajes[] = 'El registro fue editado de forma exitosa.';
        $mSession->claseMensaje = 'confirmacion';
        $this->_redirect('/modulo-cliente/admin#usuarios');
    }

    public function cambiarClaveAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->_getParam('clave_actual') &&
           $this->_getParam('clave_nueva') &&
           $this->_getParam('clave_nueva_2')){

            if($this->_getParam('clave_nueva') == $this->_getParam('clave_nueva_2')) {

                $usuario = new Default_Model_DemoUsuarioWeb();
                $where = $usuario->getAdapter()->quoteInto("id=?", $this->usuario->id);
                $row = $usuario->fetchRow($where);

                if($row->clave == md5($this->_getParam('clave_actual'))){
                    
                    $mSession->mensajes[] = 'Su clave ha sido cambiada de forma satisfactoria (Demo mensaje, en realidad no se ha cambiado).';
                    $mSession->claseMensaje = 'confirmacion';
                } else {
                    $mSession->mensajes[] = 'La CLAVE ACTUAL ingresada es incorrecta.';
                    $mSession->claseMensaje = 'errors';
                }
            } else {
                $mSession->mensajes[] = 'Por favor ingrese correctamente los datos solicitados.';
                $mSession->claseMensaje = 'errors';
            }
        } else {
            $mSession->mensajes[] = 'Por favor ingrese los datos solicitados.';
            $mSession->claseMensaje = 'errors';
        }
        $this->_redirect('/demo/index#opciones-usuario');
    }
}