<?php
class DemoVehiculoController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();
        if(!$auth->hasIdentity()){
            $this->_redirect('/demo-acceso');
        } else {
            $mSession = new Zend_Session_Namespace('expressauto');
            if($mSession->type_session!='demo') {
                $this->_redirect('/');
            }
        }
    }
    
    public function init()
    {
        $this->usuario = $this->view->usuario = Zend_Auth::getInstance()->getIdentity();
        $response = $this->getResponse();
        $response->insert('header', $this->view->render('header-demo.phtml'));
        $response->insert('footer', $this->view->render('footer.phtml'));
    }
    
    public function newAction()
    {
        if($this->usuario->tipo!='ADMINISTRADOR' ){
            $this->_redirect('/acceso/logout');
        }

        $mSession = new Zend_Session_Namespace('expressauto');
        if($mSession->mensajes!='') { 
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = ''; 
        }

        $cliente = new Default_Model_DemoCliente();
        $this->view->title = "ExpressAuto S.p.A. - Agregar vehículo";
        $this->view->cliente = $cliente->fetchRow('rut=' . $this->usuario->cliente);

        $request = $this->getRequest();
        $form = new Default_Form_Vehiculo('/demo/index#vehiculos');
        $form->setAction('/demo-vehiculo/new');

         if ($this->getRequest()->isPost()) {
             
            if ($form->isValid($request->getPost())) {

                $optionsVehiculo = array('table' => 'demo_vehiculos', 'field' => 'patente');
                $validadorVehiculo = new Zend_Validate_Db_RecordExists($optionsVehiculo);

                if($validadorVehiculo->isValid(strtoupper($form->getValue('patente')))) {

                    $mSession->mensajes[] = 'La patente que ha ingreso ya se encuentra registrada';
                    $mSession->claseMensaje = 'errors';
                    $this->_redirect('/demo-vehiculo/new');

                } else {
                    try {
                        $vehiculo = new Default_Model_DemoVehiculo();
                        $row = $vehiculo->createRow();
                        $row->cliente = $this->usuario->cliente;
                        $row->patente = strtoupper($form->getValue('patente'));
                        $row->marca = Default_Model_MarcaVehiculo::getNombreById($form->getValue('marca_id'));
                        $row->modelo = $form->getValue('modelo');
                        $row->version = $form->getValue('version');
                        $row->cilindrada = $form->getValue('cilindrada');
                        $row->traccion = $form->getValue('traccion');
                        $row->transmision = $form->getValue('transmision');
                        $row->tipo_combustible = $form->getValue('tipo_combustible');
                        $row->anio = $form->getValue('anio');
                        $row->color = $form->getValue('color');
                        $row->save();
                        $mSession->mensajes[] = 'El vehículo fue ingresado de forma exitosa.';
                        $mSession->claseMensaje = 'confirmacion';
                    } catch (Exception $e) {
                        $mSession->mensajes[] = $e->getMessage();
                        $mSession->mensajes[] = 'Ocurrió un error al intentar agregar el vehículo.';
                        $mSession->claseMensaje = 'errors';
                    }

                    $this->_redirect('/demo/index#vehiculos');
                }
            } else {
                 $form->populate($request->getPost());
            }
        }
        $this->view->form = $form;
    }
}