<?php
class ErrorController extends Zend_Controller_Action
{
    public function init()
    {
        $mSession = new Zend_Session_Namespace('expressauto');
        $response = $this->getResponse();
        $auth = Zend_Auth::getInstance();
        if (!$auth->hasIdentity()) {
            $response->insert('header', $this->view->render('header.phtml'));
        } else {
            $this->view->usuario = Zend_Auth::getInstance()->getIdentity();
            if($mSession->type_session=='demo') {
                $response->insert('header', $this->view->render('header-demo.phtml'));
            } else {
                $response->insert('header', $this->view->render('header-user.phtml'));
            }
        }
        $response->insert('footer', $this->view->render('footer.phtml'));
    }

    public function errorAction()
    {
        $errors = $this->_getParam('error_handler');

        switch ($errors->type) {
            case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_ROUTE:
            case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_CONTROLLER:
            case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_ACTION:

                // 404 error -- controller or action not found
                $this->getResponse()->setHttpResponseCode(404);
                $this->view->message = 'Página no encontrada';
                break;
            default:
                // application error
                $this->getResponse()->setHttpResponseCode(500);
                $this->view->message = 'Error en la aplicación';
                break;
        }

        $this->view->exception = $errors->exception;
        $this->view->request   = $errors->request;
    }
}