<?php
class IndexController extends Zend_Controller_Action
{
    public function init()
    {
        $mSession = new Zend_Session_Namespace('expressauto');
        $response = $this->getResponse();
        switch($this->_getParam('action')){
            case "index" :
                $this->view->seccion = '1';
                break;
            case "descripcion" :
                $this->view->seccion = '2';
                break;
            case "servicios" :
                $this->view->seccion = '3';
                break;
            case "productos" :
                $this->view->seccion = '4';
                break;
            case "contacto" :
                $this->view->seccion = '5';
                break;
            case "ubicacion" :
                $this->view->seccion = '6';
                break;
        }
        $auth = Zend_Auth::getInstance();
        
        if (!$auth->hasIdentity()) {
            $response->insert('header', $this->view->render('header.phtml'));
        } else {
            $this->view->usuario = Zend_Auth::getInstance()->getIdentity();
            if($mSession->type_session=='demo') {
                $response->insert('header', $this->view->render('header-demo.phtml'));
            } else {
                $response->insert('header', $this->view->render('header-user.phtml'));
            }
        }
        $response->insert('footer', $this->view->render('footer.phtml'));
    }
    
    public function indexAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');
        
        if($mSession->mensajes!='') { 
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = ''; 
        }
        
        $this->view->title = "ExpressAuto S.p.A. - Servicios de mantenimiento mecánico";
    }

    public function descripcionAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $this->view->title = "ExpressAuto S.p.A. - Descripción de la empresa";
    }

    public function serviciosAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $this->view->title = "ExpressAuto S.p.A. - Servicios";

    }

    public function productosAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $this->view->title = "ExpressAuto S.p.A. - Productos";
    }

    public function contactoAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $this->view->title = "ExpressAuto S.p.A. - Información y formulario de contacto";
        $form = new Default_Form_Contacto();

        if ($this->_request->isPost()) {
            $formData = $this->_request->getPost();
            if ($form->isValid($formData)) {

                try {

                    $mail = new App_HtmlMailer('UTF-8');
                    $mail->setSubject('Mensaje de contacto')
                         ->addTo('thomas.poulos@expressauto.cl')
                         ->addTo('ventas@expressauto.cl')
                         ->addBcc('claudiosalazarb@gmail.com')
                         ->setViewParam('remitente', $form->getValue('nombre'))
                         ->setViewParam('empresa', $form->getValue('empresa'))
                         ->setViewParam('mail', $form->getValue('mail'))
                         ->setViewParam('telefono', $form->getValue('telefono'))
                         ->setViewParam('asunto', $form->getValue('asunto'))
                         ->setViewParam('detalles', $form->getValue('detalles'))
                         ->sendHtmlTemplate('contacto.phtml');

                    $mSession->mensajes = array('Su mensaje se envió de forma satisfactoria. Nos pondremos en contacto con usted a la brevedad.');
                    $mSession->claseMensaje = 'confirmacion';

                } catch (Exception $e) {

                    $mSession->mensajes[] = 'Ocurrió un problema al enviar su mensaje, por favor inténtelo nuevamente más tarde.';
                    $mSession->mensajes[] = $e->getMessage();
                    $mSession->claseMensaje = 'error';

                }

                $this->_redirect('/contacto');

            } else {
                $this->view->mensajes = array('No ha ingresado la información solicitada para enviar su mensaje.');
                $this->view->claseMensaje = 'errors';
                $form->populate($formData);
            }
        }
        if($this->_getParam('subject')){
            $form->asunto->setValue($this->_getParam('subject'));
        }
        $this->view->form = $form;
    }

    public function ubicacionAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $this->view->title = "ExpressAuto S.p.A. - Ubicación. Cómo llegar";
    }

    public function politicasPrivacidadAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');

        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $this->view->title = "ExpressAuto S.p.A. - Políticas de privacidad";
    }

    
}