<?php
class UsuarioController extends Zend_Controller_Action
{
    public function preDispatch()
    {
        $auth = Zend_Auth::getInstance();
        if(!$auth->hasIdentity()){
            $this->_redirect('/acceso');
        } else {
            $mSession = new Zend_Session_Namespace('expressauto');
            if($mSession->type_session=='demo') {
                $this->_redirect('/');
            }
        }
    }
    
    public function init()
    {
        $this->usuario = $this->view->usuario = Zend_Auth::getInstance()->getIdentity();
        $response = $this->getResponse();
        $response->insert('header', $this->view->render('header-user.phtml'));
        $response->insert('footer', $this->view->render('footer.phtml'));
    }
       
    public function newAction()
    {
        if($this->usuario->tipo_acceso_web!='MULTIUSUARIO' || $this->usuario->tipo!='ADMINISTRADOR'){
            $this->_redirect('/acceso/logout');
        }

        $mSession = new Zend_Session_Namespace('expressauto');
        if($mSession->mensajes!='') { 
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = ''; 
        }
        
        $form = new Default_Form_Usuario('/modulo-cliente/admin#usuarios');
        $this->view->form = $form;
        $this->view->title = "ExpressAuto S.p.A. - Nuevo usuario";
        
        if ($this->_request->isPost()) { 
            $formData = $this->_request->getPost(); 
            if ($form->isValid($formData)) {
                    
                $usuario = new Default_Model_Usuario();
                $row = $usuario->createRow();
                $row->cliente = App_Rut::cleanToDb($this->usuario->cliente);
                $row->nombre = $form->getValue('nombre');
                $row->tipo = $form->getValue('tipo');
                $row->telefono = $form->getValue('telefono');
                $row->mail = $form->getValue('mail');
                $row->clave = '123456';
                $row->save();

                $mSession->mensajes[] = 'El usuario fue creado de forma exitosa.';
                $mSession->claseMensaje = 'confirmacion';
                $this->_redirect('/modulo-cliente/admin#usuarios');
                    
            } else {
                $form->populate($formData);
            }
        }
    }

    public function editAction()
    {
        if($this->usuario->tipo_acceso_web!='MULTIUSUARIO' || $this->usuario->tipo!='ADMINISTRADOR'){
            $this->_redirect('/acceso/logout');
        }
        
        $mSession = new Zend_Session_Namespace('expressauto');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $form = new Default_Form_Usuario('/modulo-cliente/admin#usuarios');
        $form->setAction('/usuario/edit');
        $form->submit->setLabel('Guardar cambios');
        
        $this->view->title = "ExpressAuto S.p.A. - Editar usuario";

        if ($this->_request->isPost()) {
            $formData = $this->_request->getPost();
            if ($form->isValid($formData)) {

                    $usuario = new Default_Model_Usuario();
                    $id = (int)$form->getValue('id');
                    $row = $usuario->fetchRow('id='.$id);
                    $row->nombre = $form->getValue('nombre');
                    $row->telefono = $form->getValue('telefono');
                    $row->mail = $form->getValue('mail');
                    $row->tipo = $form->getValue('tipo');
                    $row->save();
                    $mSession->mensajes[] = 'El registro fue editado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/modulo-cliente/admin#usuarios');

            } else {
                $form->populate($formData);
            }
        } else {

            $id = (int)$this->_request->getParam('id');
            $usuario = new Default_Model_Usuario();
            $where = $usuario->getAdapter()->quoteInto("id=?", $id);
            $row = $usuario->fetchRow($where);
            $form->populate($row->toArray());
            if($row->id==$this->usuario->id){
                $form->tipo->setAttrib('disabled', 'disabled');
            }
        }
        $this->view->form = $form;
    }

    public function deshabilitarAction()
    {
        if($this->usuario->tipo_acceso_web!='MULTIUSUARIO' || $this->usuario->tipo!='ADMINISTRADOR'){
            $this->_redirect('/acceso/logout');
        }
        
        $mSession = new Zend_Session_Namespace('expressauto');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $usuario = new Default_Model_Usuario();
        $id = (int)$this->_getParam('id');

        $row = $usuario->fetchRow('id='.$id);
        $row->estado = 'DESHABILITADO';
        $row->save();

        $mSession->mensajes[] = 'El registro fue editado de forma exitosa.';
        $mSession->claseMensaje = 'confirmacion';
        $this->_redirect('/modulo-cliente/admin#usuarios');

    }

    public function habilitarAction()
    {
        if($this->usuario->tipo_acceso_web!='MULTIUSUARIO' || $this->usuario->tipo!='ADMINISTRADOR'){
            $this->_redirect('/acceso/logout');
        }
        
        $mSession = new Zend_Session_Namespace('expressauto');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        $usuario = new Default_Model_Usuario();
        $id = (int)$this->_getParam('id');

        $row = $usuario->fetchRow('id='.$id);
        $row->estado = 'HABILITADO';
        $row->save();

        $mSession->mensajes[] = 'El registro fue editado de forma exitosa.';
        $mSession->claseMensaje = 'confirmacion';
        $this->_redirect('/modulo-cliente/admin#usuarios');
    }

    public function cambiarClaveAction()
    {
        $mSession = new Zend_Session_Namespace('expressauto');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->_getParam('clave_actual') && 
           $this->_getParam('clave_nueva') &&
           $this->_getParam('clave_nueva_2')){

            if($this->_getParam('clave_nueva') == $this->_getParam('clave_nueva_2')) {

                $usuario = new Default_Model_Usuario();
                $where = $usuario->getAdapter()->quoteInto("id=?", $this->usuario->id);
                $row = $usuario->fetchRow($where);
                
                if($row->clave == md5($this->_getParam('clave_actual'))){
                    $row->clave = md5($this->_getParam('clave_nueva'));
                    $row->save();

                    $mSession->mensajes[] = 'Su clave ha sido cambiada de forma satisfactoria.';
                    $mSession->claseMensaje = 'confirmacion';
                } else {
                    $mSession->mensajes[] = 'La CLAVE ACTUAL ingresada es incorrecta.';
                    $mSession->claseMensaje = 'errors';
                }
            } else {
                $mSession->mensajes[] = 'Por favor ingrese correctamente los datos solicitados.';
                $mSession->claseMensaje = 'errors';
            }
        } else {
            $mSession->mensajes[] = 'Por favor ingrese los datos solicitados.';
            $mSession->claseMensaje = 'errors';
        }

        if($this->usuario->tipo_acceso_web=='MULTIUSUARIO'){
            if($this->usuario->tipo=='ADMINISTRADOR'){
                $this->_redirect('/modulo-cliente/admin#opciones-usuario');
            } elseif($this->usuario->tipo=='CONDUCTOR') {
                $this->_redirect('/modulo-cliente/conductor#opciones-usuario');
            }
        } else {
            $this->_redirect('/modulo-cliente/base#opciones-usuario');
        }
    }
}