<?php
class VehiculoController extends Zend_Controller_Action
{
    public function preDispatch()
    { 
        $auth = Zend_Auth::getInstance(); 
        if(!$auth->hasIdentity()){ 
            $this->_redirect('/acceso');
        } else {
            $mSession = new Zend_Session_Namespace('expressauto');
            if($mSession->type_session=='demo') {
                $this->_redirect('/');
            }
        }
    }
    
    public function init()
    {
        $this->usuario = $this->view->usuario = Zend_Auth::getInstance()->getIdentity();
        $response = $this->getResponse();
        $response->insert('header', $this->view->render('header-user.phtml'));
        $response->insert('footer', $this->view->render('footer.phtml'));
    }
    
    public function newAction()
    {
        if($this->usuario->tipo!='ADMINISTRADOR' ){
            $this->_redirect('/acceso/logout');
        }

        $mSession = new Zend_Session_Namespace('expressauto');
        if($mSession->mensajes!='') { 
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = ''; 
        }
        
        $cliente = new Default_Model_Cliente();
        $this->view->title = "ExpressAuto S.p.A. - Agregar vehículo";
        $this->view->cliente = $cliente->fetchRow('rut=' . $this->usuario->cliente);

        if($this->usuario->tipo_acceso_web=='MULTIUSUARIO') {
            $back = '/modulo-cliente/admin#vehiculos';
        } else {
            $back = '/modulo-cliente/base#vehiculos';
        }

        $request = $this->getRequest();
        $form = new Default_Form_Vehiculo($back);
        
         if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {

                $optionsVehiculo = array('table' => 'vehiculos', 'field' => 'patente');
                $validadorVehiculo = new Zend_Validate_Db_RecordExists($optionsVehiculo);

                if($validadorVehiculo->isValid(strtoupper($form->getValue()))) {

                    $mSession->mensajes[] = 'La patente que ha ingreso ya se encuentra registrada';
                    $mSession->claseMensaje = 'error';
                    $this->_redirect('/modulo-cliente/error-patente');

                } else {
                    try {
                        $vehiculo = new Default_Model_Vehiculo();
                        $row = $vehiculo->createRow();
                        $row->cliente = $this->usuario->cliente;
                        $row->patente = strtoupper($form->getValue('patente'));
                        $row->marca_id = $form->getValue('marca_id');
                        $row->modelo = $form->getValue('modelo');
                        $row->version = $form->getValue('version');
                        $row->cilindrada = $form->getValue('cilindrada');
                        $row->traccion = $form->getValue('traccion');
                        $row->transmision = $form->getValue('transmision');
                        $row->tipo_combustible = $form->getValue('tipo_combustible');
                        $row->anio = $form->getValue('anio');
                        $row->color = $form->getValue('color');
                        $row->creado_via = 'WEB';
                        $row->save();
                        $mSession->mensajes[] = 'El vehículo fue ingresado de forma exitosa.';
                        $mSession->claseMensaje = 'confirmacion';
                    } catch (Exception $e) {
                        $mSession->mensajes[] = 'Ocurrió un error al intentar agregar el vehículo.';
                        $mSession->claseMensaje = 'errors';
                    }

                    if($this->usuario->tipo_acceso_web=='MULTIUSUARIO' && $this->usuario->tipo=='ADMINISTRADOR'){
                            $this->_redirect('/modulo-cliente/admin#opciones-usuario');
                    } elseif($this->usuario->tipo_acceso_web=='MONOUSUARIO' && $this->usuario->tipo=='ADMINISTRADOR') {
                        $this->_redirect('/modulo-cliente/base#opciones-usuario');
                    } else {
                        $this->_redirect('/acceso/logout');
                    }
                    
                }
            } else {
                 $form->populate($request->getPost());
            }
        }
        $this->view->form = $form;
    }
    
    /*
    public function editAction()
    {
        if($this->usuario->tipo=='ADMINISTRADOR') {
            $this->_redirect('/acceso/logout');
        }
        
        $mSession = new Zend_Session_Namespace('expressauto');
        if($mSession->mensajes!='') {
            $this->view->mensajes = $mSession->mensajes;
            $this->view->claseMensaje = $mSession->claseMensaje;
            $mSession->mensajes = '';
            $mSession->claseMensaje = '';
        }

        if($this->usuario->tipo_acceso_web=='MULTIUSUARIO') {
            if($this->usuario->tipo=='ADMINISTRADOR') {
                $back = '/modulo-cliente/admin#vehiculos';
            }
        } else {
            $back = '/modulo-cliente/base#vehiculos';
        }

        $form = new Default_Form_Vehiculo('/modulo-cliente/admin#vehiculos');
        $form->setAction('/vehiculo/edit');
        $form->submit->setLabel('guardar cambios');

        $this->view->title = "ExpressAuto S.p.A. - Editar vehículo";

        if ($this->_request->isPost()) {
            $formData = $this->_request->getPost();
            if ($form->isValid($formData)) {

                    $vehiculo = new Default_Model_Vehiculo();
                    $row = $vehiculo->fetchRow("patente='".$form->getValue('patente')."'");
                    $row->marca_id = $form->getValue('marca_id');
                    $row->modelo = $form->getValue('modelo');
                    $row->version = $form->getValue('version');
                    $row->cilindrada = $form->getValue('cilindrada');
                    $row->traccion = $form->getValue('traccion');
                    $row->transmision = $form->getValue('transmision');
                    $row->tipo_combustible = $form->getValue('tipo_combustible');
                    $row->anio = $form->getValue('anio');
                    $row->color = $form->getValue('color');
                    $row->save();

                    $mSession->mensajes[] = 'El registro fue editado de forma exitosa.';
                    $mSession->claseMensaje = 'confirmacion';
                    $this->_redirect('/modulo-cliente');

            } else {
                $form->populate($formData);
            }
        } else {

            $id = $this->_request->getParam('id');
            $vehiculo = new Default_Model_Vehiculo();
            $row = $vehiculo->fetchRow("patente='$id'");
            $form->populate($row->toArray());
            $this->view->form = $form;
        }
    }*/
}