<?php
class Default_Form_Acceso extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);
        
        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Email')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('EmailAddress')
              ->setErrorMessages(array('Por favor ingrese una dirección de Email válida'));
              
        $clave = new Zend_Form_Element_Password('clave');
        $clave->setLabel('Clave')
              ->setRequired(true)
              ->addFilter('StripTags');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Ingresar')
               ->setAttrib('class', 'submit-button');
        
        $this->addElements(array($mail, $clave, $submit));

        $this->addDisplayGroup(
            array(
                'mail', 'clave'
            ),
            'grupo1',
            array(
                'legend' => 'Iniciar sesión'
            )
        );

        $grupo1 = $this->getDisplayGroup('grupo1');
        $grupo1->setDecorators(
                array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array(
                'submit'
            ),
            'gsubmit'
        );

        $gsubmit = $this->getDisplayGroup('gsubmit');
        $gsubmit->setDecorators(
                array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','style'=>'clear:both;'))
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido',
                'name'      => 'acceso',
                'action'    => '/acceso/iniciar-sesion'
            ));
   }
} 
