<?php
class Default_Form_CambiarClave extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);
              
        $clave1 = new Zend_Form_Element_Password('clave1');
        $clave1->setLabel('Ingrese su nueva clave')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('StringLength', false, array(6,10))
              ->addValidator('Alnum')
              ->setErrorMessages(array('La nueva clave debe tener entre 6 y 10 caractéres alfanuméricos (sólo letras y números)'));
              
        $clave2 = new Zend_Form_Element_Password('clave2');
        $clave2->setLabel('Reingrese su nueva clave')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('Identical', false, array('token' => 'clave1'))
              ->setErrorMessages(array('Debe introducir la misma clave que en el campo anterior'));
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Cambiar clave')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(array($clave1, $clave2, $submit));
        $this->addDisplayGroup( 
            array('clave1','clave2'),
            'clavesInputs',
            array('legend' => 'Cambiar clave de acceso')
        );

        $clavesInputs = $this->getDisplayGroup('clavesInputs');
        $clavesInputs->setDecorators(
                array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
                array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'tab-form',
                'name'      => 'cambiar-clave',
                'action'    => '/ayuda/cambiar-clave'
            ));
       

    } 
} 
