<?php
class Default_Form_Cliente extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);

        $validadorRut = new App_Validate_ValidRut();

        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre completo')
               ->setRequired(true)
               ->addFilter('StripTags')
               ->addFilter('StringTrim');
              
        $rut = new Zend_Form_Element_Text('rut');
        $rut->setLabel('R.U.T.')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator($validadorRut);
              
        $direccion = new Zend_Form_Element_Text('direccion');
        $direccion->setLabel('Dirección')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
              
        $comuna = new Zend_Form_Element_Text('comuna');
        $comuna->setLabel('Comuna')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
              
        $ciudad = new Zend_Form_Element_Text('ciudad');
        $ciudad->setLabel('Ciudad')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
              
        $telefono = new Zend_Form_Element_Text('telefono');
        $telefono->setLabel('Teléfono')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');

        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Email')
             ->setRequired(true)
             ->addValidator('EmailAddress')
             ->addFilter('StripTags')
             ->addFilter('StringTrim');

        $web = new Zend_Form_Element_Text('web');
        $web->setLabel('Web')
             ->setRequired(false)
             ->addFilter('StripTags')
             ->addFilter('StringTrim');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Registrar')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(array(
            $nombre, $rut, $direccion, $comuna,
            $ciudad, $telefono, $mail, $web,
            $submit
            ));

        $this->addDisplayGroup(
            array(
                'nombre', 'rut', 'direccion', 'telefono'
            ),
            'grupo1'
        );

        $grupo1 = $this->getDisplayGroup('grupo1');
        $grupo1->setDecorators(
                array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
           array(
                'comuna', 'ciudad', 'mail', 'web'
            ),
            'grupo2'
        );

        $grupo2 = $this->getDisplayGroup('grupo2');
        $grupo2->setDecorators(
                array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left2'))
            )
        );

        $this->addDisplayGroup(
            array('submit'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
                array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido',
                'name'      => 'registro',
                'action'    => '/registro'
            ));
    } 
} 
