<?php
class Default_Form_Contacto extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
              
        $empresa = new Zend_Form_Element_Text('empresa');
        $empresa->setLabel('Empresa')
              ->setRequired(false)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');      
              
        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Email')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('EmailAddress');
              
        $telefono = new Zend_Form_Element_Text('telefono');
        $telefono->setLabel('Teléfono')
              ->setRequired(true)
              ->addFilter('StripTags');

        $asunto = new Zend_Form_Element_Text('asunto');
        $asunto->setLabel('Asunto')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
             
        $detalles = new Zend_Form_Element_Textarea('detalles');
        $detalles->setLabel('Mensaje')
              ->setRequired(true)
              ->setAttrib('style', 'height:125px;')
              ->addFilter('StripTags') 
              ->addFilter('StringTrim'); 
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Enviar mensaje')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(array($nombre, $empresa, $mail, $telefono, $asunto, $detalles, $submit));

        $this->addDisplayGroup(
            array(
                'nombre', 'empresa', 'mail',
                'telefono'
            ),
            'grupo1'
        );

        $grupo1 = $this->getDisplayGroup('grupo1');
        $grupo1->setDecorators(
                array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array(
                'asunto', 'detalles'
            ),
            'grupo2'
        );

        $grupo2 = $this->getDisplayGroup('grupo2');
        $grupo2->setDecorators(
                array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
                array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido',
                'name'      => 'contacto',
                'action'    => '/index/contacto'
            ));
    } 
} 
