<?php
class Default_Form_ContactoCliente extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);


        $optionsCliente = array('table' => 'clientes', 'field' => 'rut');
        $validadorCliente = new Zend_Validate_Db_RecordExists($optionsCliente);

        $cliente = new Zend_Form_Element_Hidden('cliente');
        $cliente->setRequired(true)
                ->addValidator($validadorCliente)
                ->setDecorators(array('ViewHelper'));
        
        $nombre = new Zend_Form_Element_Text('nombre');
        $nombre->setLabel('Nombre')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
              
        $telefono = new Zend_Form_Element_Text('telefono');
        $telefono->setLabel('Teléfono')
              ->setRequired(false)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
              
        $movil = new Zend_Form_Element_Text('movil');
        $movil->setLabel('Teléfono móvil')
              ->setRequired(false)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
           
        $fax = new Zend_Form_Element_Text('fax');
        $fax->setLabel('Fax')
              ->setRequired(false)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
              
        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Email')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('EmailAddress');
              
        $promociones = new Zend_Form_Element_Checkbox('promociones');
        $promociones->setLabel('¿Desea recibir avisos de promociones y ofertas en su correo electrónico?');
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Ir al siguiente paso')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(
            array(
                $cliente, $nombre, $telefono, $movil,
                $fax, $mail, $promociones, $submit
            )
        );


        $this->addDisplayGroup(
            array(
                'nombre', 'mail', 'telefono'
            ),
            'grupo1'
        );

        $grupo1 = $this->getDisplayGroup('grupo1');
        $grupo1->setDecorators(
                array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
           array(
                'movil', 'fax'
            ),
            'grupo2'
        );

        $grupo2 = $this->getDisplayGroup('grupo2');
        $grupo2->setDecorators(
                array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array(
                'promociones'
            ),
            'inputCheckboxes'
        );

        $inputCheckboxes = $this->getDisplayGroup('inputCheckboxes');
        $inputCheckboxes->setDecorators(
                array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-checkbox'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'cliente'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
                array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido',
                'name'      => 'registro',
                'action'    => '/registro/info-contacto'
            ));
    } 
} 
