<?php
class Default_Form_DespachoDocumentos extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);

        $cotizaciones = new Zend_Form_Element_Select('recep_cotizaciones');
        $cotizaciones->setLabel('Deseo recibir las cotizaciones vía')
              ->setRequired(true)
              ->addMultiOption('','- Seleccionar -')
              ->addMultiOption('MAIL','Email')
              ->addMultiOption('FAX','Fax')
              ->addMultiOption('CORREO','Correo tradicional')
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
              
              
        $guias = new Zend_Form_Element_Select('recep_guias_despacho');
        $guias->setLabel('Deseo recibir las guías de despacho vía')
              ->setRequired(true)
              ->addMultiOption('','- Seleccionar -')
              ->addMultiOption('MAIL','Email')
              ->addMultiOption('FAX','Fax')
              ->addMultiOption('CORREO','Correo tradicional')
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');
              
        $facturas = new Zend_Form_Element_Select('recep_facturas');
        $facturas->setLabel('Deseo recibir las facturas vía')
              ->setRequired(true)
              ->addMultiOption('','- Seleccionar -')
              ->addMultiOption('MAIL','Email')
              ->addMultiOption('FAX','Fax')
              ->addMultiOption('CORREO','Correo tradicional')
              ->addFilter('StripTags') 
              ->addFilter('StringTrim');      
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Guardar preferencias')
               ->setAttrib('class', 'submit-button');
        
        $this->addElements(array($cotizaciones, $guias, $facturas, $submit));
            

        $this->addDisplayGroup(
            array(
                'recep_cotizaciones', 'recep_guias_despacho', 'recep_facturas'
            ),
            'grupo1',
            array(
                'legend'=>'Por favor, seleccione como desea recibir los siguientes documentos'
            )
        );

        $grupo1 = $this->getDisplayGroup('grupo1');
        $grupo1->setDecorators(
                array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array(
                'submit'
            ),
            'gsubmit'
        );

        $gsubmit = $this->getDisplayGroup('gsubmit');
        $gsubmit->setDecorators(
                array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','style'=>'clear:both;'))
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido',
                'name'      => 'preferencias',
                'action'    => '/modulo-cliente/preferencias'
            ));

    } 
} 
