<?php
class Default_Form_Informe extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);
             

        $fecha_i = new Zend_Form_Element_Text('fecha_i');
        $fecha_i->setLabel('Desde')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator('Date');
              
        $fecha_t = new Zend_Form_Element_Text('fecha_t');
        $fecha_t->setLabel('Hasta')
              ->setRequired(true)
              ->addFilter('StripTags')
              ->addFilter('StringTrim')
              ->addValidator('Date');

        $formato = new Zend_Form_Element_Select('formato');
        $formato->setLabel('Formato')
              ->setRequired(true)
              ->addMultiOption('','-- Seleccionar --')
              ->addMultiOption('web', 'Ver en pantalla')
              ->addMultiOption('pdf', 'PDF')
              ->addMultiOption('xls', 'XLS (Excel)');


        $submit = new Zend_Form_Element_Submit('submit_informe');
        $submit->setLabel('crear informe');
        
        $this->addElements(array($fecha_i, $fecha_t, $formato, $submit));
            
        $this->addDisplayGroup(
            array(
              'fecha_i', 'fecha_t', 'formato', 'submit_informe'
            ),
            'grupo1',
            array(
                'legend'=>'Seleccione el rango de fechas y el formato de salida para crear el informe'
            )
        );

        $grupo1 = $this->getDisplayGroup('grupo1');
        $grupo1->setDecorators(
                array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'name'      => 'finforme'
            ));
    } 
} 
