<?php
class Default_Form_NuevaClave extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);

        $options = array( 'table' => 'usuarios_web', 'field' => 'id');
        $validadorUsuario = new Zend_Validate_Db_RecordExists($options);

        $id = new Zend_Form_Element_Hidden('id');
        $id->setRequired(true)
                   ->addvalidator('Int')
                   ->addValidator($validadorUsuario);
              
        $clave1 = new Zend_Form_Element_Password('clave1');
        $clave1->setLabel('Ingrese su nueva clave')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('StringLength', false, array(6,10))
              ->addValidator('Alnum')
              ->setErrorMessages(array('La nueva clave debe tener entre 6 y 10 caractéres alfanuméricos (sólo letras y números)'));
              
        $clave2 = new Zend_Form_Element_Password('clave2');
        $clave2->setLabel('Reingrese su nueva clave')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('Identical', false, array('token' => 'clave1'))
              ->setErrorMessages(array('Debe introducir la misma clave que en el primer campo'));
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Cambiar clave')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(array($id, $clave1, $clave2, $submit));
        $this->addDisplayGroup( array('clave1', 'clave2'), 'clavesInputs');

        $clavesInputs = $this->getDisplayGroup('clavesInputs');
        $clavesInputs->setDecorators(
                array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(
            array('submit', 'id'),
            'submitButtons'
        );

        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
                array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido',
                'name'      => 'nueva-clave',
                'action'    => '/ayuda/nueva-clave'
            ));
       

    } 
} 
