<?php
class Default_Form_RecuperarClave extends Zend_Form
{ 
    public function __construct($options = null) 
    { 
        parent::__construct($options);

        $options = array('table' => 'usuarios_web', 'field' => 'mail');
        $validadorEmail = new Zend_Validate_Db_RecordExists($options);
              
        $mail = new Zend_Form_Element_Text('mail');
        $mail->setLabel('Email')
              ->setRequired(true)
              ->addFilter('StripTags') 
              ->addFilter('StringTrim')
              ->addValidator('EmailAddress')
              ->addValidator($validadorEmail);
        
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel('Solicitar clave')
               ->setDecorators(array('ViewHelper'));
        
        $this->addElements(array($mail, $submit));
            
        $this->addDisplayGroup(array('mail'), 'grupo1');
        $grupo1 = $this->getDisplayGroup('grupo1');
        $grupo1->setDecorators(
                array(
                'FormElements',
                'Fieldset',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-left'))
            )
        );

        $this->addDisplayGroup(array('submit'), 'submitButtons');
        $submitButtons = $this->getDisplayGroup('submitButtons');
        $submitButtons->setDecorators(
                array(
                'FormElements',
                array('HtmlTag',array('tag'=>'div','class'=>'form-float-buttons'))
            )
        );

        $this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('Form')
             ->setAttribs(array(
                'class'     => 'dividido',
                'name'      => 'recuperar-clave',
                'action'    => '/ayuda/solicitar-clave'
            ));
    } 
} 
