<?php
class Default_Model_Venta extends Zend_Db_Table_Abstract
{
    protected $_name = 'ventas';
    protected $_primary = 'venta_id';

    private $venta_id;
    private $cliente_id;


    public function setId($venta_id)
    {
        $this->venta_id = $venta_id;
    }


    public function setClienteId($cliente_id)
    {
        $this->cliente_id= $cliente_id;
    }


    public function getAll()
    {
        $db = $this->getAdapter();
        $select = $db->select()
            ->from('ventas', array(
                'venta_id',
                'DATE_FORMAT(fecha,\'%d-%m-%Y\') AS fecha',
                'titulo',
                'descripcion',
                'factura'))
            ->join('sucursales', 'sucursales.sucursal_id=ventas.sucursal_id', array('sucursal' => 'ciudad'))
            ->join('vehiculos', 'vehiculos.vehiculo_id=ventas.vehiculo_id', array('vehiculo' => 'patente'))
            ->where('vehiculos.cliente_id = ? ', $this->cliente_id);
        $result = $db->fetchAll($select);
        return $result;
    }

    public function getRowsByVehiculo($vehiculo_id)
    {
        $db = Zend_Registry::get('db');
        $select = $db->select()
            ->from('ventas', array(
                'venta_id',
                'DATE_FORMAT(fecha,\'%d-%m-%Y\') AS fecha',
                'titulo',
                'descripcion',
                'factura'))
            ->join('sucursales', 'sucursales.sucursal_id=ventas.sucursal_id', array('sucursal' => 'ciudad'))
            ->where('ventas.vehiculo_id = ?', $vehiculo_id);
        $result = $db->fetchAll($select);
        return $result;
    }


    public function getRowsByFactura($factura)
    {
        $db = Zend_Registry::get('db');
        $select = $db->select()
            ->from('ventas', array(
                'venta_id',
                'DATE_FORMAT(fecha,\'%d-%m-%Y\') AS fecha',
                'titulo',
                'descripcion',
                'factura'))
            ->join('sucursales', 'sucursales.sucursal_id=ventas.sucursal_id', array('sucursal' => 'ciudad'))
            ->join('vehiculos', 'vehiculos.vehiculo_id=ventas.vehiculo_id', array('vehiculo' => 'patente'))
            ->where('ventas.factura = ? ', $factura);
        $result = $db->fetchAll($select);
        return $result;
    }

    public function getRowsById($venta_id)
    {
        $db = Zend_Registry::get('db');
        $select = $db->select()
            ->from('ventas', array(
                'venta_id',
                'DATE_FORMAT(fecha,\'%d-%m-%Y\') AS fecha',
                'titulo',
                'descripcion',
                'factura'))
            ->join('sucursales', 'sucursales.sucursal_id=ventas.sucursal_id', array('sucursal' => 'ciudad'))
            ->where('ventas.venta_id = ? ', $venta_id);
        $result = $db->fetchRow($select);
        return $result;
    }
}